program digiconv;

{ umwandeln mac-sd2 in pc-wave datei
 die wave-datei-intelligenz stammt aus wavinfo2}

uses crt, dos;

type wave=record
       riff:array[1..4] of char;  {RIFF}
       lang1:longint;             {Dateilnge minus 8 byte}
       wav:array[1..8] of char;   {WAVEfmt_}
       lang2:longint;             {hex: 10 00 00 00}
       form:word;                 {Format, hier eins}
       mo_st:word;                {mono: 1, stereo: 2}
       srate:longint;             {Samplerate}
       byte_sec:longint;          {durchschnittliche bytes pro sec}
       byte_samp:word;            {bytes pro sample}
       bits:word;                 {verwendete bits}
       data:array[1..4] of char;  {data}
       lang3:longint;             {laenge der sampledaten}
     end;

var f_in, f_out : file of byte;
    datin, datout, aktion : string;
    a, b, c, tmp_x, tmp_y : byte;
    i, ziel : longint;
    bitrate, z : word;
    samprate : longint;

procedure tausch16;
begin
  i:=0;
  repeat
    read(f_in, a, b);
    write(f_out, b, a);
    inc(i, 2);
    if i mod 4096 = 0 then begin
      gotoxy(tmp_x,tmp_y);
      write(i/ziel*100:6:2,' %');
    end;
  until eof(f_in);
  gotoxy(tmp_x,tmp_y);
  writeln(i,' byte');
end;

procedure tausch24;
begin
  i:=0;
  repeat
    read(f_in, a, b, c);
    write(f_out, c, b, a);
    inc(i, 3);
    if i mod 4096 = 0 then begin
      gotoxy(tmp_x,tmp_y);
      write(i/ziel*100:6:2,' %');
    end;
  until eof(f_in);
  gotoxy(tmp_x,tmp_y);
  writeln(i,' byte');
end;

procedure wav_kopf;
var f_wav:file of wave;
    kopf:wave;
begin
  with kopf do begin
    riff:='RIFF';
    lang1:=ziel+36;          { lnge des in-files + 44 byte header - 8 }
    wav:='WAVEfmt ';
    lang2:=16;               { dezimalwert von hex: 10 00 00 00 }
    form:=1;                 { Format, hier eins}
    mo_st:=1;                { mono: 1, stereo: 2}
    srate:=samprate;                             { Samplerate}
    byte_sec:=trunc(samprate*(bitrate/8)*mo_st); { bytes pro sec }
    byte_samp:=trunc((bitrate/8)*mo_st);         { bytes pro sample }
    bits:=bitrate;                               { verwendete bits }
    data:='data';
    lang3:=ziel;
  end;
  assign(f_wav, datout);
  rewrite(f_wav);
  write(f_wav, kopf);
  close(f_wav);
  writeln('wave-header geschrieben');
end;

procedure start;
begin
  { open file in, get size }
  assign(f_in, datin);
  reset(f_in);
  ziel:=filesize(f_in);

  if aktion='2wav' then wav_kopf;
  assign(f_out, datout);
  if aktion='2wav' then reset(f_out)
    else rewrite(f_out);
  seek(f_out, filesize(f_out));
  tmp_x:=wherex;
  tmp_y:=wherey;
  if bitrate=16 then tausch16;
  if bitrate=24 then tausch24;
  close(f_in);
  close(f_out);
end;

procedure parameter;
begin
  if paramcount <> 5 then begin
    writeln('quell-, zieldatei, aktion, bit- und samplerate bergeben');
    exit;
  end;
  { no checking for existance yet! }
  datin:=paramstr(1);
  datout:=paramstr(2);
  aktion:=paramstr(3);
  if (aktion<>'2wav') and (aktion<>'2sd') then begin
    writeln('ungltige aktion');
    halt;
  end;
  val(paramstr(4), bitrate, z);
  if (bitrate<>16) and (bitrate<>24) and (z<>0) then begin
    writeln('ungltige bitrate');
    halt;
  end;
  val(paramstr(5), samprate, z);
  if (samprate<11000) and (samprate>96000) and (z<>0) then begin
    writeln('ungltige samplerate');
    halt;
  end;
end;

begin
  parameter;
  writeln('start (',bitrate,' / ',samprate,')...');
  start;
  writeln('ende');
  exit;
end.
